/*global require, process, console */

var path = require('path'),
    control = require('../'),
    task = control.task;

task('mycluster', 'Config for my cluster', function () {
    var config, addresses;
    config = {
        user: process.env.USER
    };
    addresses = [ 'localhost' ];
    return control.hosts(config, addresses); 
});

function doTest(host, code, callback, exitCallback) {
    var script = process.argv[1];

    code = code || 0; 
    host.ssh('node ' + script + ' mycluster arbexit ' + code,
            callback, exitCallback);
}

// Task to perform 'remote' call requesting 'remote' to exit arbitrarily
task('test', 'Test task', function (host, code) {

    function callback() {
        console.log('Regular callback activated for ' + host.address);
    }

    function exitCallback(exit) {
        console.log('Exit callback activated for ' + host.address +
        ' with exit code ' + exit);
    }

    doTest(host, code, callback, exitCallback);
});

// Task to perform 'remote' call requesting 'remote' to exit arbitrarily
task('test:dual', 'Test with combined callback and exit callback', 
        function (host, code) {
    function dualCallback(exit) {
        console.log('Dual callback activated for ' + host.address +
        ' with exit code ' + exit);        
    } 
    dualCallback.handlesExit = true;
    
    doTest(host, code, dualCallback);
});

// That that will run on 'remote' to exit with an arbitrary code
task('arbexit', 'Arbitrary exit', function (host, code) {
    code = code || 0; 
    console.log("Exiting with code " + code);
    process.exit(code);
});

control.begin();

// Run like
// node mycontroller.js mycluster test 64 
