/*global require */

// That that setting member with this always sets the member on the inheriting
// object rather than the prototype even when the method is defined on the
// protoytpe.

var assert = require('assert'),
    a, b;

function setX(x) {
    this.x = x;
}

function setY(y) {
    this.y = y;
}

a = {};
b = Object.create(a);

assert.equal(a.x, undefined);

a.x = 2;

assert.equal(a.x, 2);
assert.equal(b.x, 2);

a.setX = setX;
b.setX(3);

assert.equal(a.x, 2);
assert.equal(b.x, 3);

assert.equal(a.y, undefined);

a.setY = setY;
b.setY(4);

assert.equal(a.y, undefined);
assert.equal(b.y, 4);
